/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;

public class Stellwerk {
	public static void main(String[] args) {
		JMenuBar mb;
		JMenu menu;
		
		fpl = new Fahrplan();
		hf = new Hauptfenster ();
		
		f = new JFrame ("Stellwerk-Simulation Guettingen (c) 2005 Simon Gander");
		f.setLayout (null);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		mb = new JMenuBar();
		f.setJMenuBar(mb);
		menu = new JMenu("Datei");
		
		jcbmi_testmodus = new JCheckBoxMenuItem("Testmodus");
		jcbmi_testmodus.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				Hauptfenster.anz.setTestmodus(jcbmi_testmodus.getState());
			}
		});
		menu.add(jcbmi_testmodus);
		menu.addSeparator();
		menu.add("Beenden").addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		mb.add(menu);
		
		menu = new JMenu("Fahrplan");
		menu.add("Laden...").addActionListener (new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				JFileChooser chooser = new JFileChooser();
				int returnVal = chooser.showOpenDialog(f);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					try {
						fpl.laden(chooser.getSelectedFile());
					} catch (IOException ex) {
//						ex.printStackTrace();
					}
				}
			}
		});
		menu.add("Abbrechen").addActionListener (new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fpl.abbrechen();
			}
		});
		mb.add(menu);
		
		f.setResizable(false);
		f.setVisible(true);
		f.setContentPane(hf);
		f.pack();
	}
	
	static Hauptfenster hf;
	static JFrame f;
	static JCheckBoxMenuItem jcbmi_testmodus;
	
	static Fahrplan fpl;
	
	static final long serialVersionUID = -7896811756886984312L;
}
