/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPopupMenu;

public class Weichenhebel extends Hebel implements Runnable {
	public Weichenhebel(int nr, String ns, boolean iso_tab[]) {
		super (nr, ns);
		hebel_plus = wh_plus;
		hebel_minus = wh_minus;
		hat_fb_hebel = false;
		hebelsperre = weichen_hsp;
		isoliertabelle = iso_tab;
		
		hsp_menu = new JPopupMenu();
		hsp_menu.add("Isolierumgehung fr Weichen").addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				hebelsperreEinschalten();
			}
		});
	}

	public void setWeiche(Weiche w) {
		weiche = w;
	}

	@Override
	public void positionPlus() {
		if ((verschlossen != 0) || !position) return;
		pruefeHebelsperre();
		if (!hebelsperre_frei) return;
		new Thread(this, "WeichenhebelPlus").start();
		position = false;
		weiche.stellen(false);		
	}
	
	@Override
	public void positionMinus() {
		if ((verschlossen != 0) || position) return;
		pruefeHebelsperre();
		if (!hebelsperre_frei) return;
		new Thread(this, "WeichenhebelMinus").start();
		position = true;
		weiche.stellen(true);		
	}
	
	@Override
	public void run() {
		try {
			Thread.sleep(200);
			weichenhebel_sound.play();
			Thread.sleep(1600);
			hebelsperreAusschalten();
		} catch (InterruptedException e) {
			System.err.println("Interrupted Exception");
		}
	}
	
	/* Das hier wird wohl noch auf Vektorgrafik umgestellt ... */
	@Override
	public void drawLampe (Graphics g) {
		if (hebelsperre_frei) g.setColor (Color.YELLOW);
		else g.setColor (Color.DARK_GRAY);
		g.drawLine (28, 11, 31, 11);
		g.drawLine (27, 12, 32, 12);
		g.drawLine (26, 13, 33, 13);
		g.drawLine (26, 14, 33, 14);
		g.drawLine (26, 15, 33, 15);
		g.drawLine (26, 16, 33, 16);
		g.drawLine (27, 17, 32, 17);
		g.drawLine (28, 18, 31, 18);
	}

	public void weicheVerschliessen () {
		verschlossen++;
	}
	
	public void weichenverschlussAufheben () {
		if (verschlossen <= 0) System.out.println ("Weichenfreigabe: Weiche nicht gesperrt");
		verschlossen--;
	}

	@Override
	public void pruefeHebelsperre() {
		if (Fahrstrasse.pruefeWeichenIsolierungen(isoliertabelle)) hebelsperreEinschalten();
	}

	Weiche weiche;
	int verschlossen;
	boolean isoliertabelle[];
}
